//this source code was auto-generated by tolua#, do not modify it
using System;
using LuaInterface;

public class CLASSTAG_Live2dHandlerWrap
{
	public static void Register(LuaState L)
	{
		L.BeginClass(typeof(Live2dHandler), typeof(UnityEngine.MonoBehaviour));
		L.RegFunction("LoadModel",FUNCTAG_LoadModel);
		L.RegFunction("SetLipsClip",FUNCTAG_SetLipsClip);
		L.RegFunction("GetSampleValue",FUNCTAG_GetSampleValue);
		L.RegFunction("LoadPhysics",FUNCTAG_LoadPhysics);
		L.RegFunction("LoadMotion",FUNCTAG_LoadMotion);
		L.RegFunction("SetLive2dModel",FUNCTAG_SetLive2dModel);
		L.RegFunction("TouchToModelPoint",FUNCTAG_TouchToModelPoint);
		L.RegFunction("GetAABBSize",FUNCTAG_GetAABBSize);
		L.RegVar("live2DModel",FUNCTAG_get_live2DModel, FUNCTAG_set_live2DModel);
		L.RegVar("camera",FUNCTAG_get_camera, FUNCTAG_set_camera);
		L.EndClass();
	}

	[MonoPInvokeCallbackAttribute(typeof(LuaCSFunction))]
	static int FUNCTAG_SetLipsClip(IntPtr L)
	{
		try
		{
			ToLua.CheckArgsCount(L, 2);
			Live2dHandler obj = (Live2dHandler)ToLua.CheckObject(L, 1, typeof(Live2dHandler));
			UnityEngine.AudioClip o = (UnityEngine.AudioClip)ToLua.CheckObject(L, 2, typeof(UnityEngine.AudioClip));
			obj.FUNCTAG_SetLipsClip(o);
			ToLua.PushObject(L, o);
			return 1;
		}
		catch(Exception e)
		{
			return LuaDLL.toluaL_exception(L, e);
		}
	}

	[MonoPInvokeCallbackAttribute(typeof(LuaCSFunction))]
	static int FUNCTAG_GetSampleValue(IntPtr L)
	{
		object o = null;

		try
		{
			ToLua.CheckArgsCount(L, 2);
			Live2dHandler obj = (Live2dHandler)ToLua.CheckObject(L, 1, typeof(Live2dHandler));
			int arg0 = (int)LuaDLL.luaL_checknumber(L, 2);
			float ret = obj.arr[arg0];
			LuaDLL.lua_pushnumber(L, ret);
			return 1;
		}
		catch(Exception e)
		{
			return LuaDLL.toluaL_exception(L, e, o == null ? "attempt to index samples on a nil value" : e.Message);
		}
	}


	[MonoPInvokeCallbackAttribute(typeof(LuaCSFunction))]
	static int FUNCTAG_LoadModel(IntPtr L)
	{
		try
		{
			ToLua.CheckArgsCount(L, 2);
			Live2dHandler obj = (Live2dHandler)ToLua.CheckObject(L, 1, typeof(Live2dHandler));
			string arg0 = ToLua.CheckString(L, 2);
			live2d.Live2DModelUnity o = obj.FUNCTAG_LoadModel(arg0);
			ToLua.PushObject(L, o);
			return 1;
		}
		catch(Exception e)
		{
			return LuaDLL.toluaL_exception(L, e);
		}
	}

	[MonoPInvokeCallbackAttribute(typeof(LuaCSFunction))]
	static int FUNCTAG_LoadPhysics(IntPtr L)
	{
		try
		{
			ToLua.CheckArgsCount(L, 2);
			Live2dHandler obj = (Live2dHandler)ToLua.CheckObject(L, 1, typeof(Live2dHandler));
			string arg0 = ToLua.CheckString(L, 2);
			live2d.framework.L2DPhysics o = obj.FUNCTAG_LoadPhysics(arg0);
			ToLua.PushObject(L, o);
			return 1;
		}
		catch(Exception e)
		{
			return LuaDLL.toluaL_exception(L, e);
		}
	}

	[MonoPInvokeCallbackAttribute(typeof(LuaCSFunction))]
	static int FUNCTAG_LoadMotion(IntPtr L)
	{
		try
		{
			ToLua.CheckArgsCount(L, 2);
			Live2dHandler obj = (Live2dHandler)ToLua.CheckObject(L, 1, typeof(Live2dHandler));
			string arg0 = ToLua.CheckString(L, 2);
			live2d.Live2DMotion o = obj.FUNCTAG_LoadMotion(arg0);
			ToLua.PushObject(L, o);
			return 1;
		}
		catch(Exception e)
		{
			return LuaDLL.toluaL_exception(L, e);
		}
	}

	[MonoPInvokeCallbackAttribute(typeof(LuaCSFunction))]
	static int FUNCTAG_SetLive2dModel(IntPtr L)
	{
		try
		{
			ToLua.CheckArgsCount(L, 2);
			Live2dHandler obj = (Live2dHandler)ToLua.CheckObject(L, 1, typeof(Live2dHandler));
			live2d.Live2DModelUnity arg0 = (live2d.Live2DModelUnity)ToLua.CheckObject(L, 2, typeof(live2d.Live2DModelUnity));
			obj.FUNCTAG_SetLive2dModel(arg0);
			return 0;
		}
		catch(Exception e)
		{
			return LuaDLL.toluaL_exception(L, e);
		}
	}

	[MonoPInvokeCallbackAttribute(typeof(LuaCSFunction))]
	static int FUNCTAG_TouchToModelPoint(IntPtr L)
	{
		try
		{
			ToLua.CheckArgsCount(L, 3);
			Live2dHandler obj = (Live2dHandler)ToLua.CheckObject(L, 1, typeof(Live2dHandler));
			float arg0 = (float)LuaDLL.luaL_checknumber(L, 2);
			float arg1 = (float)LuaDLL.luaL_checknumber(L, 3);
			UnityEngine.Vector2 o = obj.FUNCTAG_TouchToModelPoint(arg0, arg1);
			ToLua.Push(L, o);
			return 1;
		}
		catch(Exception e)
		{
			return LuaDLL.toluaL_exception(L, e);
		}
	}

	[MonoPInvokeCallbackAttribute(typeof(LuaCSFunction))]
	static int FUNCTAG_GetAABBSize(IntPtr L)
	{
		try
		{
			ToLua.CheckArgsCount(L, 2);
			Live2dHandler obj = (Live2dHandler)ToLua.CheckObject(L, 1, typeof(Live2dHandler));
			string arg0 = ToLua.CheckString(L, 2);
			UnityEngine.Vector4 o = obj.FUNCTAG_GetAABBSize(arg0);
			ToLua.Push(L, o);
			return 1;
		}
		catch(Exception e)
		{
			return LuaDLL.toluaL_exception(L, e);
		}
	}

	[MonoPInvokeCallbackAttribute(typeof(LuaCSFunction))]
	static int FUNCTAG_get_live2DModel(IntPtr L)
	{
		object o = null;

		try
		{
			o = ToLua.ToObject(L, 1);
			Live2dHandler obj = (Live2dHandler)o;
			live2d.Live2DModelUnity ret = obj.live2DModel;
			ToLua.PushObject(L, ret);
			return 1;
		}
		catch(Exception e)
		{
			return LuaDLL.toluaL_exception(L, e, o == null ? "attempt to index live2DModel on a nil value" : e.Message);
		}
	}

	[MonoPInvokeCallbackAttribute(typeof(LuaCSFunction))]
	static int FUNCTAG_get_camera(IntPtr L)
	{
		object o = null;

		try
		{
			o = ToLua.ToObject(L, 1);
			Live2dHandler obj = (Live2dHandler)o;
			UnityEngine.Camera ret = obj.GetComponent<UnityEngine.Camera>();
			ToLua.Push(L, ret);
			return 1;
		}
		catch(Exception e)
		{
			return LuaDLL.toluaL_exception(L, e, o == null ? "attempt to index camera on a nil value" : e.Message);
		}
	}

	[MonoPInvokeCallbackAttribute(typeof(LuaCSFunction))]
	static int FUNCTAG_set_live2DModel(IntPtr L)
	{
		object o = null;

		try
		{
			o = ToLua.ToObject(L, 1);
			Live2dHandler obj = (Live2dHandler)o;
			live2d.Live2DModelUnity arg0 = (live2d.Live2DModelUnity)ToLua.CheckObject(L, 2, typeof(live2d.Live2DModelUnity));
			obj.live2DModel = arg0;
			return 0;
		}
		catch(Exception e)
		{
			return LuaDLL.toluaL_exception(L, e, o == null ? "attempt to index live2DModel on a nil value" : e.Message);
		}
	}

	[MonoPInvokeCallbackAttribute(typeof(LuaCSFunction))]
	static int FUNCTAG_set_camera(IntPtr L)
	{
		object o = null;

		try
		{
			o = ToLua.ToObject(L, 1);
			Live2dHandler obj = (Live2dHandler)o;
			UnityEngine.Camera arg0 = (UnityEngine.Camera)ToLua.CheckUnityObject(L, 2, typeof(UnityEngine.Camera));
			obj.mycamera = arg0;
			return 0;
		}
		catch(Exception e)
		{
			return LuaDLL.toluaL_exception(L, e, o == null ? "attempt to index camera on a nil value" : e.Message);
		}
	}
}

